ghc-7.0.3: The GHC API

StgCmmClosure

# Documentation

data SMRep

type DynTag = Int

tagForCon :: DataCon -> DynTag

isSmallFamily :: Int -> Bool

type ConTagZ = Int

dataConTagZ :: DataCon -> ConTagZ

data ArgDescr

Constructors

ArgSpec !StgHalfWord |
ArgGen Liveness |

data Liveness

Constructors

SmallLiveness StgWord |
BigLiveness CLabel |

data C_SRT

Constructors

NoC_SRT |
C_SRT !CLabel !WordOff !StgHalfWord |

Instances

Eq C_SRT |
Outputable C_SRT |

needsSRT :: C_SRT -> Bool

isVoidRep :: PrimRep -> Bool

isGcPtrRep :: PrimRep -> Bool

addIdReps :: [Id] -> [(PrimRep, Id)]

addArgReps :: [StgArg] -> [(PrimRep, StgArg)]

argPrimRep :: StgArg -> PrimRep

data LambdaFormInfo

data StandardFormInfo

mkLFThunk :: Type -> TopLevelFlag -> [Id] -> UpdateFlag -> LambdaFormInfo

mkLFReEntrant :: TopLevelFlag -> [Id] -> [Id] -> ArgDescr -> LambdaFormInfo

mkConLFInfo :: DataCon -> LambdaFormInfo

mkSelectorLFInfo :: Id -> Int -> Bool -> LambdaFormInfo

mkApLFInfo :: Id -> UpdateFlag -> Arity -> LambdaFormInfo

mkLFImported :: Id -> LambdaFormInfo

mkLFArgument :: Id -> LambdaFormInfo

mkLFLetNoEscape :: LambdaFormInfo

lfDynTag :: LambdaFormInfo -> DynTag

data ClosureInfo

mkClosureInfo :: Bool -> Id -> LambdaFormInfo -> Int -> Int -> C_SRT -> String -> ClosureInfo

mkConInfo :: Bool -> DataCon -> Int -> Int -> ClosureInfo

maybeIsLFCon :: LambdaFormInfo -> Maybe DataCon

closureSize :: ClosureInfo -> WordOff

closureNonHdrSize :: ClosureInfo -> WordOff

closureGoodStuffSize :: ClosureInfo -> WordOff

closurePtrsSize :: ClosureInfo -> WordOff

slopSize :: ClosureInfo -> WordOff

closureName :: ClosureInfo -> Name

infoTableLabelFromCI :: ClosureInfo -> CLabel

closureLabelFromCI :: ClosureInfo -> CLabel

closureTypeInfo :: ClosureInfo -> ((ConstrDescription -> ClosureTypeInfo) -> DataCon -> CLabel -> a) -> (ClosureTypeInfo -> a) -> a

closureLFInfo :: ClosureInfo -> LambdaFormInfo

isLFThunk :: LambdaFormInfo -> Bool

closureSMRep :: ClosureInfo -> SMRep

closureUpdReqd :: ClosureInfo -> Bool

closureNeedsUpdSpace :: ClosureInfo -> Bool

closureIsThunk :: ClosureInfo -> Bool

closureSingleEntry :: ClosureInfo -> Bool

closureReEntrant :: ClosureInfo -> Bool

isConstrClosure_maybe :: ClosureInfo -> Maybe DataCon

closureFunInfo :: ClosureInfo -> Maybe (Int, ArgDescr)

isStandardFormThunk :: LambdaFormInfo -> Bool

isKnownFun :: LambdaFormInfo -> Bool

funTag :: ClosureInfo -> DynTag

tagForArity :: Int -> DynTag

enterIdLabel :: Name -> CafInfo -> CLabel

enterLocalIdLabel :: Name -> CafInfo -> CLabel

nodeMustPointToIt :: LambdaFormInfo -> Bool

data CallMethod

Constructors

EnterIt |
JumpToIt |
ReturnIt |
SlowCall |
DirectEntry CLabel Int |

getCallMethod :: DynFlags -> Name -> CafInfo -> LambdaFormInfo -> Int -> CallMethod

blackHoleOnEntry :: DynFlags -> ClosureInfo -> Bool

getClosureType :: Bool -> WordOff -> LambdaFormInfo -> ClosureType

isToplevClosure :: ClosureInfo -> Bool

closureValDescr :: ClosureInfo -> String

closureTypeDescr :: ClosureInfo -> String

isStaticClosure :: ClosureInfo -> Bool

cafBlackHoleClosureInfo :: ClosureInfo -> ClosureInfo

staticClosureNeedsLink :: ClosureInfo -> Bool

clHasCafRefs :: ClosureInfo -> CafInfo